﻿using System;
using System.Collections.Concurrent;

namespace ProducerConsumerBlockingCollection
{
    public class Consumer
    {
        private readonly BlockingCollection<int> _buffer;

        public Consumer(BlockingCollection<int> buffer)
        {
            if (buffer == null) { throw new ArgumentNullException("buffer"); }
            _buffer = buffer;
        }

        public void Run()
        {
            while (!_buffer.IsCompleted)
            {
                try
                {
                    int element = _buffer.Take();
                    Console.WriteLine("Consumer: " + element);
                }
                catch (InvalidOperationException) { /* ignored */ }
            }
        }
    }
}
