﻿using System;
using System.Collections.Concurrent;

namespace ProducerConsumerBlockingCollection
{
    public class Producer
    {
        private readonly BlockingCollection<int> _buffer;
        private readonly int _howMany;

        public Producer(BlockingCollection<int> buffer, int howMany)
        {
            if (buffer == null) { throw new ArgumentNullException("buffer"); }
            if (howMany <= 0) { throw new ArgumentOutOfRangeException("howMany"); }
            _buffer = buffer;
            _howMany = howMany;
        }

        public void Run()
        {
            for (int i = 0; i < _howMany; i++)
            {
                _buffer.Add(i);
                Console.WriteLine("Producer: " + i);
            }
            _buffer.CompleteAdding();
        }
    }
}
