﻿using System.Collections.Concurrent;
using System.Threading.Tasks;

namespace ProducerConsumerBlockingCollection
{
    class Program
    {
        static void Main()
        {
            ProducerConsumer();
            //Producer2Consumer();
            //TwoProducerConsumer();
            //ProducerMiddleManConsumer();
        }

        private static void ProducerConsumer()
        {
            BlockingCollection<int> buffer = new BlockingCollection<int>(4);
            Producer producer = new Producer(buffer, 10);
            Consumer consumer = new Consumer(buffer);
            Parallel.Invoke(producer.Run, consumer.Run);
        }

        private static void Producer2Consumer()
        {
            BlockingCollection<int> buffer = new BlockingCollection<int>(4);
            Producer producer = new Producer(buffer, 10);
            Consumer consumer1 = new Consumer(buffer);
            Consumer consumer2 = new Consumer(buffer);
            Parallel.Invoke(producer.Run, consumer1.Run, consumer2.Run);
        }

        // InvalidOperationException
        private static void TwoProducerConsumer()
        {
            BlockingCollection<int> buffer = new BlockingCollection<int>(4);
            Producer producer = new Producer(buffer, 10);
            Producer producer2 = new Producer(buffer, 10);
            Consumer consumer = new Consumer(buffer);
            Parallel.Invoke(producer.Run, producer2.Run, consumer.Run);
        }

        private static void ProducerMiddleManConsumer()
        {
            BlockingCollection<int> buffer1 = new BlockingCollection<int>(4);
            BlockingCollection<int> buffer2 = new BlockingCollection<int>(3);
            Producer producer = new Producer(buffer1, 10);
            MiddleMan middleman = new MiddleMan(buffer1, buffer2);
            Consumer consumer = new Consumer(buffer2);
            Parallel.Invoke(producer.Run, middleman.Run, consumer.Run);
        }
    }
}
